> This page is for Developer.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.bigcommerce.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.bigcommerce.com/_mcp/server.

# Create Multiple Metafields

POST https://api.bigcommerce.com/stores/{store_hash}/v3/catalog/variants/metafields
Content-Type: application/json

Create multiple metafields.

Reference: https://docs.bigcommerce.com/developer/api-reference/rest/admin/catalog/product-variants/batch-metafields/create-variants-metafields

## Authentication

- `X-Auth-Token` header (required) — ### OAuth scopes | UI Name | Permission | Parameter | |:--------|:-----------|:----------| | Products | modify | `store_v2_products` | | Products | read-only | `store_v2_products_read_only` | ### Authentication header | Header | Argument | Description | |:-------|:---------|:------------| | `X-Auth-Token` | `access_token` | For more about API accounts that generate `access_token`s, see our [Guide to API Accounts](/developer/docs/overview/api-fundamentals/api-accounts#api-accounts). | ### Further reading For example requests and more information about authenticating BigCommerce APIs, see [Authentication and Example Requests](/developer/docs/overview/api-fundamentals/api-accounts#x-auth-token-header-example-requests). For more about BigCommerce OAuth scopes, see our [Guide to API Accounts](/developer/docs/overview/api-fundamentals/api-accounts#oauth-scopes). For a list of API status codes, see [API Status Codes](/developer/api-reference/rest/overview#rest-http-status-codes).

## Request

### Path parameters

- `store_hash` (string, required) — Permanent ID of the BigCommerce store.

### Headers

- `Accept` (string, required, default: application/json) — The [MIME type](https://developer.mozilla.org/en-US/docs/Web/HTTP/Basics_of_HTTP/MIME_types) of the response body.

### Body (application/json)

This endpoint expects a list of CatalogVariantsMetafieldsPostRequestBodyContentApplicationJsonSchemaItems.

- `list of CatalogVariantsMetafieldsPostRequestBodyContentApplicationJsonSchemaItems`

## Response

### 200

List of created `Metafield` objects.

- `data` (list of Metafield, optional)
- `errors` (list of any, optional) — Empty for 200 responses.
- `meta` (CollectionMeta, optional) — Data about the response, including pagination and collection totals.

## Errors

### 400 Bad Request Error

Bad Request. Input is invalid.

- `status` (double, optional)
- `title` (string, optional)
- `type` (string, optional)
- `detail` (string, optional)

### 422 Unprocessable Entity Error

Response object for metafields creation with partial success.

- `data` (list of Metafield, optional)
- `errors` (list of Error, optional)
- `meta` (WriteCollectionPartialSuccessMeta, optional) — Additional data about the response.

## Types

### CatalogVariantsMetafieldsPostRequestBodyContentApplicationJsonSchemaItems

Common metafield properties.

- `key` (string, required) — The name of the field, for example: `location_id`, `color`.
- `value` (string, required) — The value of the field, for example: `1`, `blue`.
- `namespace` (string, required) — Namespace for the metafield, for organizational purposes.
- `permission_set` (enum, required) — Determines the visibility and writeability of the field by other API consumers. | Value | Description | | :--- | :--- | | `app_only` | Private to the app that owns the field. | | `read` | Visible to other API consumers. | | `write` | Open for reading and writing by other API consumers. | | `read_and_sf_access` | Visible to other API consumers, including on the storefront. | | `write_and_sf_access` | Open for reading and writing by other API consumers, including on the storefront. |
  - Allowed values: `app_only`, `read`, `write`, `read_and_sf_access`, `write_and_sf_access`
- `resource_id` (integer, required) — The ID for the product variant with which the metafield is associated.
- `description` (string, optional) — Description for the metafields.

### Metafield

Common metafield properties.

- `id` (integer, optional) — The unique identifier for the metafield.
- `key` (string, optional) — The name of the field, for example: `location_id`, `color`.
- `value` (string, optional) — The value of the field, for example: `1`, `blue`.
- `namespace` (string, optional) — Namespace for the metafield, for organizational purposes.
- `permission_set` (enum, optional) — Determines the visibility and writeability of the field by other API consumers. | Value | Description | | :--- | :--- | | `app_only` | Private to the app that owns the field. | | `read` | Visible to other API consumers. | | `write` | Open for reading and writing by other API consumers. | | `read_and_sf_access` | Visible to other API consumers, including on the storefront. | | `write_and_sf_access` | Open for reading and writing by other API consumers, including on the storefront. |
  - Allowed values: `app_only`, `read`, `write`, `read_and_sf_access`, `write_and_sf_access`
- `resource_type` (enum, optional) — The type of resource with which the metafield is associated.
  - Allowed values: `brand`, `product`, `variant`, `category`, `cart`, `channel`, `location`, `order`, `customer`
- `resource_id` (integer, optional) — The unique identifier for the resource with which the metafield is associated.
- `description` (string, optional) — Description for the metafields.
- `date_created` (datetime, optional) — Date and time of the metafieldʼs creation.
- `date_modified` (datetime, optional) — Date and time when the metafield was last updated.
- `owner_client_id` (string, optional) — Client ID for the metafieldʼs creator.

### CollectionMeta

Data about the response, including pagination and collection totals.

- `pagination` (CollectionMetaPagination, optional) — Data about the response, including pagination and collection totals.

### Error

Error response payload for the BigCommerce API.

- `status` (integer, optional) — The HTTP status code for the error.
- `title` (string, optional) — The error title.
- `type` (string, optional) — The error type.
- `errors` (ErrorDetail, optional) — Error detail response payload for the BigCommerce API.

### WriteCollectionPartialSuccessMeta

Additional data about the response.

- `total` (integer, optional) — Total number of items in the result set.
- `success` (integer, optional) — Total number of items that were successfully deleted.
- `failed` (integer, optional) — Total number of items that failed to be deleted.

### CollectionMetaPagination

Data about the response, including pagination and collection totals.

- `total` (integer, optional) — Total number of items in the result set.
- `count` (integer, optional) — Total number of items in the collection response.
- `per_page` (integer, optional) — The amount of items returned in the collection per page, controlled by the limit parameter.
- `current_page` (integer, optional) — The page you are currently on within the collection.
- `total_pages` (integer, optional) — The total number of pages in the collection.
- `links` (CollectionMetaPaginationLinks, optional) — Pagination links for the previous and next parts of the whole collection.

### ErrorDetail

Error detail response payload for the BigCommerce API.

### CollectionMetaPaginationLinks

Pagination links for the previous and next parts of the whole collection.

- `previous` (string, optional) — Link to the previous page returned in the response.
- `current` (string, optional) — Link to the current page returned in the response.
- `next` (string, optional) — Link to the next page returned in the response.

## Examples

**Request**

```json
[
  {
    "key": "location_id",
    "value": "Shelf 3, Bin 5",
    "namespace": "App Namespace",
    "permission_set": "app_only",
    "resource_id": 42
  }
]
```

**Response**

```json
{
  "data": [
    {
      "id": 1,
      "key": "Staff Name",
      "value": "Ronaldo",
      "namespace": "Sales Department",
      "permission_set": "app_only",
      "resource_type": "cart",
      "resource_id": 424242,
      "description": "order",
      "date_created": "2022-06-16T18:39:00+00:00",
      "date_modified": "2022-06-16T18:39:00+00:00",
      "owner_client_id": "asdfasdfasdfasdfasdfasdfasdf"
    }
  ],
  "errors": [],
  "meta": {
    "pagination": {
      "total": 36,
      "count": 36,
      "per_page": 50,
      "current_page": 1,
      "total_pages": 1,
      "links": {
        "previous": "string",
        "current": "?page=1&limit=50",
        "next": "string"
      }
    }
  }
}
```

**SDK Code**

```python Create variant metafields in batch
import requests

url = "https://api.bigcommerce.com/stores/store_hash/v3/catalog/variants/metafields"

payload = [
    {
        "key": "location_id",
        "value": "Shelf 3, Bin 5",
        "namespace": "App Namespace",
        "permission_set": "app_only",
        "resource_id": 42
    }
]
headers = {
    "Accept": "application/json",
    "X-Auth-Token": "<apiKey>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript Create variant metafields in batch
const url = 'https://api.bigcommerce.com/stores/store_hash/v3/catalog/variants/metafields';
const options = {
  method: 'POST',
  headers: {
    Accept: 'application/json',
    'X-Auth-Token': '<apiKey>',
    'Content-Type': 'application/json'
  },
  body: '[{"key":"location_id","value":"Shelf 3, Bin 5","namespace":"App Namespace","permission_set":"app_only","resource_id":42}]'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Create variant metafields in batch
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.bigcommerce.com/stores/store_hash/v3/catalog/variants/metafields"

	payload := strings.NewReader("[\n  {\n    \"key\": \"location_id\",\n    \"value\": \"Shelf 3, Bin 5\",\n    \"namespace\": \"App Namespace\",\n    \"permission_set\": \"app_only\",\n    \"resource_id\": 42\n  }\n]")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Accept", "application/json")
	req.Header.Add("X-Auth-Token", "<apiKey>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Create variant metafields in batch
require 'uri'
require 'net/http'

url = URI("https://api.bigcommerce.com/stores/store_hash/v3/catalog/variants/metafields")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Accept"] = 'application/json'
request["X-Auth-Token"] = '<apiKey>'
request["Content-Type"] = 'application/json'
request.body = "[\n  {\n    \"key\": \"location_id\",\n    \"value\": \"Shelf 3, Bin 5\",\n    \"namespace\": \"App Namespace\",\n    \"permission_set\": \"app_only\",\n    \"resource_id\": 42\n  }\n]"

response = http.request(request)
puts response.read_body
```

```java Create variant metafields in batch
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.bigcommerce.com/stores/store_hash/v3/catalog/variants/metafields")
  .header("Accept", "application/json")
  .header("X-Auth-Token", "<apiKey>")
  .header("Content-Type", "application/json")
  .body("[\n  {\n    \"key\": \"location_id\",\n    \"value\": \"Shelf 3, Bin 5\",\n    \"namespace\": \"App Namespace\",\n    \"permission_set\": \"app_only\",\n    \"resource_id\": 42\n  }\n]")
  .asString();
```

```php Create variant metafields in batch
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.bigcommerce.com/stores/store_hash/v3/catalog/variants/metafields', [
  'body' => '[
  {
    "key": "location_id",
    "value": "Shelf 3, Bin 5",
    "namespace": "App Namespace",
    "permission_set": "app_only",
    "resource_id": 42
  }
]',
  'headers' => [
    'Accept' => 'application/json',
    'Content-Type' => 'application/json',
    'X-Auth-Token' => '<apiKey>',
  ],
]);

echo $response->getBody();
```

```csharp Create variant metafields in batch
using RestSharp;

var client = new RestClient("https://api.bigcommerce.com/stores/store_hash/v3/catalog/variants/metafields");
var request = new RestRequest(Method.POST);
request.AddHeader("Accept", "application/json");
request.AddHeader("X-Auth-Token", "<apiKey>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "[\n  {\n    \"key\": \"location_id\",\n    \"value\": \"Shelf 3, Bin 5\",\n    \"namespace\": \"App Namespace\",\n    \"permission_set\": \"app_only\",\n    \"resource_id\": 42\n  }\n]", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift Create variant metafields in batch
import Foundation

let headers = [
  "Accept": "application/json",
  "X-Auth-Token": "<apiKey>",
  "Content-Type": "application/json"
]
let parameters = [
  [
    "key": "location_id",
    "value": "Shelf 3, Bin 5",
    "namespace": "App Namespace",
    "permission_set": "app_only",
    "resource_id": 42
  ]
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.bigcommerce.com/stores/store_hash/v3/catalog/variants/metafields")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```